package com.ejie.ab63.model.OTC;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Zonas  
 * 
 *  
 */

public class Zonas implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idZona;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<OficinasTecnicas> oficinasTecnicases = new ArrayList<OficinasTecnicas>();

	/**
	 * Method 'Zonas'.
	 */
	public Zonas() {
	}

	/**
	 * Method 'Zonas'.
	 * 
	 * @param idZona
	 *            Long
	 */
	public Zonas(Long idZona) {
		this.idZona = idZona;
	}

	/**
	 * Method 'Zonas'.
	 * 
	 * @param idZona
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public Zonas(Long idZona, String descripcionCastellano, String descripcionEuskera, Date fechaRegistro,
			String usuarioRegistro) {
		this.idZona = idZona;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'Zonas'.
	 * 
	 * @param idZona
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param oficinasTecnicases
	 *            List<OficinasTecnicas>
	 */
	public Zonas(Long idZona, String descripcionCastellano, String descripcionEuskera, Date fechaRegistro,
			String usuarioRegistro, List<OficinasTecnicas> oficinasTecnicases) {

		this.idZona = idZona;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.oficinasTecnicases = oficinasTecnicases;
	}

	/**
	 * Method 'getIdZona'.
	 *
	 * @return Long
	 */

	public Long getIdZona() {
		return this.idZona;
	}

	/**
	 * Method 'setIdZona'.
	 *
	 * @param idZona
	 *            Long
	 * @return
	 */

	public void setIdZona(Long idZona) {
		this.idZona = idZona;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getOficinasTecnicases'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<OficinasTecnicas> getOficinasTecnicases() {
		return this.oficinasTecnicases;
	}

	/**
	 * Method 'setOficinasTecnicases'.
	 *
	 * @param oficinasTecnicases
	 *            List
	 * @return
	 */
	public void setOficinasTecnicases(List<OficinasTecnicas> oficinasTecnicases) {
		this.oficinasTecnicases = oficinasTecnicases;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idZona: ").append(this.idZona).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
